# flake8: noqa

"""
    Quotes API For Digital Portals

    The Quotes API combines endpoints for retrieving security end-of-day, delayed, and realtime prices with performance key figures and basic reference data on the security and market level.  The API supports over 20 different price types for each quote and comes with basic search endpoints based on security identifiers and instrument names. Market coverage is included in the *Sample Use Cases* section below.  The Digital Portal use case is focused on high-performance applications that are  * serving millions of end-users, * accessible by client browsers via the internet, * supporting subscriptions for streamed updates out-of-the-box, * typically combining a wide variety of *for Digital Portals*-APIs into a highly use-case specific solution for customers, * integrated into complex infrastructures such as existing frontend frameworks, authentication services.  All APIs labelled *for Digital Portals* have been designed for direct use by client web applications and feature extreme low latency: The average response time across all endpoints is 30 ms whereas 99% of all requests are answered in close to under 300ms.  See the [Time Series API for Digital Portals](https://developer.factset.com/api-catalog/time-series-api-digital-portals) for direct access to price histories, and the [News API for Digital Portals](https://developer.factset.com/api-catalog/news-api-digital-portals) for searching and fetching related news.   # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


__version__ = "0.10.6"

# import ApiClient
from fds.sdk.QuotesAPIforDigitalPortals.api_client import ApiClient

# import Configuration
from fds.sdk.QuotesAPIforDigitalPortals.configuration import Configuration

# import exceptions
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import OpenApiException
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiAttributeError
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiTypeError
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiValueError
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiKeyError
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiException
