"""
    Quotes API For Digital Portals

    The Quotes API combines endpoints for retrieving security end-of-day, delayed, and realtime prices with performance key figures and basic reference data on the security and market level.  The API supports over 20 different price types for each quote and comes with basic search endpoints based on security identifiers and instrument names. Market coverage is included in the *Sample Use Cases* section below.  The Digital Portal use case is focused on high-performance applications that are  * serving millions of end-users, * accessible by client browsers via the internet, * supporting subscriptions for streamed updates out-of-the-box, * typically combining a wide variety of *for Digital Portals*-APIs into a highly use-case specific solution for customers, * integrated into complex infrastructures such as existing frontend frameworks, authentication services.  All APIs labelled *for Digital Portals* have been designed for direct use by client web applications and feature extreme low latency: The average response time across all endpoints is 30 ms whereas 99% of all requests are answered in close to under 300ms.  See the [Time Series API for Digital Portals](https://developer.factset.com/api-catalog/time-series-api-digital-portals) for direct access to price histories, and the [News API for Digital Portals](https://developer.factset.com/api-catalog/news-api-digital-portals) for searching and fetching related news.   # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.QuotesAPIforDigitalPortals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.QuotesAPIforDigitalPortals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_distribution_fee import InlineResponse20062DataCostsAndChargesExAnteDistributionFee
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_incidental_costs import InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_italy import InlineResponse20062DataCostsAndChargesExAnteItaly
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_management_fee import InlineResponse20062DataCostsAndChargesExAnteManagementFee
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_entry_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_maximum_acquired_entry_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_maximum_acquired_exit_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_maximum_exit_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_prior_rhp_exit_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_one_off_typical_exit_cost import InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_ongoing_costs import InlineResponse20062DataCostsAndChargesExAnteOngoingCosts
    from fds.sdk.QuotesAPIforDigitalPortals.model.inline_response20062_data_costs_and_charges_ex_ante_transaction_costs import InlineResponse20062DataCostsAndChargesExAnteTransactionCosts
    globals()['InlineResponse20062DataCostsAndChargesExAnteDistributionFee'] = InlineResponse20062DataCostsAndChargesExAnteDistributionFee
    globals()['InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts'] = InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts
    globals()['InlineResponse20062DataCostsAndChargesExAnteItaly'] = InlineResponse20062DataCostsAndChargesExAnteItaly
    globals()['InlineResponse20062DataCostsAndChargesExAnteManagementFee'] = InlineResponse20062DataCostsAndChargesExAnteManagementFee
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost'] = InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost
    globals()['InlineResponse20062DataCostsAndChargesExAnteOngoingCosts'] = InlineResponse20062DataCostsAndChargesExAnteOngoingCosts
    globals()['InlineResponse20062DataCostsAndChargesExAnteTransactionCosts'] = InlineResponse20062DataCostsAndChargesExAnteTransactionCosts


class InlineResponse20062DataCostsAndChargesExAnte(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'one_off_entry_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost,),  # noqa: E501
            'italy': (InlineResponse20062DataCostsAndChargesExAnteItaly,),  # noqa: E501
            'one_off_maximum_acquired_entry_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost,),  # noqa: E501
            'one_off_maximum_exit_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost,),  # noqa: E501
            'one_off_maximum_acquired_exit_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost,),  # noqa: E501
            'one_off_typical_exit_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost,),  # noqa: E501
            'one_off_prior_rhp_exit_cost': (InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost,),  # noqa: E501
            'ongoing_costs': (InlineResponse20062DataCostsAndChargesExAnteOngoingCosts,),  # noqa: E501
            'management_fee': (InlineResponse20062DataCostsAndChargesExAnteManagementFee,),  # noqa: E501
            'distribution_fee': (InlineResponse20062DataCostsAndChargesExAnteDistributionFee,),  # noqa: E501
            'transaction_costs': (InlineResponse20062DataCostsAndChargesExAnteTransactionCosts,),  # noqa: E501
            'incidental_costs': (InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'one_off_entry_cost': 'oneOffEntryCost',  # noqa: E501
        'italy': 'italy',  # noqa: E501
        'one_off_maximum_acquired_entry_cost': 'oneOffMaximumAcquiredEntryCost',  # noqa: E501
        'one_off_maximum_exit_cost': 'oneOffMaximumExitCost',  # noqa: E501
        'one_off_maximum_acquired_exit_cost': 'oneOffMaximumAcquiredExitCost',  # noqa: E501
        'one_off_typical_exit_cost': 'oneOffTypicalExitCost',  # noqa: E501
        'one_off_prior_rhp_exit_cost': 'oneOffPriorRHPExitCost',  # noqa: E501
        'ongoing_costs': 'ongoingCosts',  # noqa: E501
        'management_fee': 'managementFee',  # noqa: E501
        'distribution_fee': 'distributionFee',  # noqa: E501
        'transaction_costs': 'transactionCosts',  # noqa: E501
        'incidental_costs': 'incidentalCosts',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """InlineResponse20062DataCostsAndChargesExAnte - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            one_off_entry_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost): [optional]  # noqa: E501
            italy (InlineResponse20062DataCostsAndChargesExAnteItaly): [optional]  # noqa: E501
            one_off_maximum_acquired_entry_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost): [optional]  # noqa: E501
            one_off_maximum_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost): [optional]  # noqa: E501
            one_off_maximum_acquired_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost): [optional]  # noqa: E501
            one_off_typical_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost): [optional]  # noqa: E501
            one_off_prior_rhp_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost): [optional]  # noqa: E501
            ongoing_costs (InlineResponse20062DataCostsAndChargesExAnteOngoingCosts): [optional]  # noqa: E501
            management_fee (InlineResponse20062DataCostsAndChargesExAnteManagementFee): [optional]  # noqa: E501
            distribution_fee (InlineResponse20062DataCostsAndChargesExAnteDistributionFee): [optional]  # noqa: E501
            transaction_costs (InlineResponse20062DataCostsAndChargesExAnteTransactionCosts): [optional]  # noqa: E501
            incidental_costs (InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """InlineResponse20062DataCostsAndChargesExAnte - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            one_off_entry_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffEntryCost): [optional]  # noqa: E501
            italy (InlineResponse20062DataCostsAndChargesExAnteItaly): [optional]  # noqa: E501
            one_off_maximum_acquired_entry_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredEntryCost): [optional]  # noqa: E501
            one_off_maximum_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumExitCost): [optional]  # noqa: E501
            one_off_maximum_acquired_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffMaximumAcquiredExitCost): [optional]  # noqa: E501
            one_off_typical_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffTypicalExitCost): [optional]  # noqa: E501
            one_off_prior_rhp_exit_cost (InlineResponse20062DataCostsAndChargesExAnteOneOffPriorRHPExitCost): [optional]  # noqa: E501
            ongoing_costs (InlineResponse20062DataCostsAndChargesExAnteOngoingCosts): [optional]  # noqa: E501
            management_fee (InlineResponse20062DataCostsAndChargesExAnteManagementFee): [optional]  # noqa: E501
            distribution_fee (InlineResponse20062DataCostsAndChargesExAnteDistributionFee): [optional]  # noqa: E501
            transaction_costs (InlineResponse20062DataCostsAndChargesExAnteTransactionCosts): [optional]  # noqa: E501
            incidental_costs (InlineResponse20062DataCostsAndChargesExAnteIncidentalCosts): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
